require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FENV_H_)) {
    eval 'sub _FENV_H_ () {1;}' unless defined(&_FENV_H_);
    require 'sys/_types.ph';
    unless(defined(&__fenv_static)) {
	eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
    }
    eval 'sub FE_INVALID () {0x1;}' unless defined(&FE_INVALID);
    eval 'sub FE_DENORMAL () {0x2;}' unless defined(&FE_DENORMAL);
    eval 'sub FE_DIVBYZERO () {0x4;}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_OVERFLOW () {0x8;}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_UNDERFLOW () {0x10;}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_INEXACT () {0x20;}' unless defined(&FE_INEXACT);
    eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_DENORMAL |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW);}' unless defined(&FE_ALL_EXCEPT);
    eval 'sub FE_TONEAREST () {0x;}' unless defined(&FE_TONEAREST);
    eval 'sub FE_DOWNWARD () {0x400;}' unless defined(&FE_DOWNWARD);
    eval 'sub FE_UPWARD () {0x800;}' unless defined(&FE_UPWARD);
    eval 'sub FE_TOWARDZERO () {0xc00;}' unless defined(&FE_TOWARDZERO);
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_DOWNWARD |  &FE_UPWARD |  &FE_TOWARDZERO);}' unless defined(&_ROUND_MASK);
    eval 'sub FE_DFL_ENV () {(& &__fe_dfl_env);}' unless defined(&FE_DFL_ENV);
    eval 'sub _FPUSW_SHIFT () {13;}' unless defined(&_FPUSW_SHIFT);
    eval 'sub __stfpsr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"mov %0=ar.fpsr\\" : \\"=r\\" (*($__r))));
    }' unless defined(&__stfpsr);
    eval 'sub __ldfpsr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"mov ar.fpsr=%0;;\\" : : \\"r\\" ($__r)));
    }' unless defined(&__ldfpsr);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub fedisableexcept {
	    my($__mask) = @_;
    	    eval q({  &fenv_t  &__newfpsr,  &__oldfpsr;  &__stfpsr(& &__oldfpsr);  &__newfpsr =  &__oldfpsr | ($__mask &  &FE_ALL_EXCEPT);  &__ldfpsr( &__newfpsr); (~ &__oldfpsr &  &FE_ALL_EXCEPT); });
	}' unless defined(&fedisableexcept);
	eval 'sub fegetexcept {
	    my($void) = @_;
    	    eval q({  &fenv_t  &__fpsr;  &__stfpsr(& &__fpsr); (~ &__fpsr &  &FE_ALL_EXCEPT); });
	}' unless defined(&fegetexcept);
    }
}
1;
