require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ENDIAN_H_)) {
    eval 'sub _MACHINE_ENDIAN_H_ () {1;}' unless defined(&_MACHINE_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
    eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__CC_SUPPORTS___INLINE)  && defined(&__GNUCLIKE_ASM)) {
	eval 'sub __bswap64 {
	    my($_x) = @_;
    	    eval q({  &__uint64_t  &__r;  &__asm  &__volatile(\\"mux1 %0=%1,@rev\\" : \\"=r\\" ( &__r) : \\"r\\"($_x));  &__r; });
	}' unless defined(&__bswap64);
	eval 'sub __bswap32 {
	    my($_x) = @_;
    	    eval q({ ( &__bswap64($_x) >> 32); });
	}' unless defined(&__bswap32);
	eval 'sub __bswap16 {
	    my($_x) = @_;
    	    eval q({ ( &__bswap64($_x) >> 48); });
	}' unless defined(&__bswap16);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__htons);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__ntohs);
    } else {
	eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
    }
}
1;
