require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_KDB_H_)) {
    eval 'sub _MACHINE_KDB_H_ () {1;}' unless defined(&_MACHINE_KDB_H_);
    require 'machine/cpufunc.ph';
    require 'machine/frame.ph';
    require 'machine/ia64_cpu.ph';
    eval 'sub KDB_STOPPEDPCB {
        my($pc) = @_;
	    eval q((($pc)-> ($pc_md->{pcb})));
    }' unless defined(&KDB_STOPPEDPCB);
    eval 'sub kdb_cpu_clear_singlestep {
        my($void) = @_;
	    eval q({  ($kdb_frame->{tf_special}->{psr}) &= ~ &IA64_PSR_SS; });
    }' unless defined(&kdb_cpu_clear_singlestep);
    eval 'sub kdb_cpu_set_singlestep {
        my($void) = @_;
	    eval q({  ($kdb_frame->{tf_special}->{psr}) |=  &IA64_PSR_SS; });
    }' unless defined(&kdb_cpu_set_singlestep);
    eval 'sub kdb_cpu_sync_icache {
        my($addr,$size) = @_;
	    eval q({  &vm_offset_t  &cacheline;  &cacheline = ( &uintptr_t)$addr & ~31; $size += ( &uintptr_t)$addr -  &cacheline; $size = ($size + 31) & ~31;  &while ($size > 0) {  &__asm  &__volatile(\\"fc %0;; sync.i;; srlz.i;;\\" :: \\"r\\"( &cacheline));  &cacheline += 32; $size -= 32; } });
    }' unless defined(&kdb_cpu_sync_icache);
}
1;
