require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_MCA_H_)) {
    eval 'sub _MACHINE_MCA_H_ () {1;}' unless defined(&_MACHINE_MCA_H_);
    eval 'sub MCA_RH_ERROR_RECOVERABLE () {0;}' unless defined(&MCA_RH_ERROR_RECOVERABLE);
    eval 'sub MCA_RH_ERROR_FATAL () {1;}' unless defined(&MCA_RH_ERROR_FATAL);
    eval 'sub MCA_RH_ERROR_CORRECTED () {2;}' unless defined(&MCA_RH_ERROR_CORRECTED);
    eval 'sub MCA_RH_FLAGS_PLATFORM_ID () {0x1;}' unless defined(&MCA_RH_FLAGS_PLATFORM_ID);
    eval 'sub MCA_RH_FLAGS_TIME_STAMP () {0x2;}' unless defined(&MCA_RH_FLAGS_TIME_STAMP);
    eval 'sub MCA_RH_TIME_SEC () {0;}' unless defined(&MCA_RH_TIME_SEC);
    eval 'sub MCA_RH_TIME_MIN () {1;}' unless defined(&MCA_RH_TIME_MIN);
    eval 'sub MCA_RH_TIME_HOUR () {2;}' unless defined(&MCA_RH_TIME_HOUR);
    eval 'sub MCA_RH_TIME_MDAY () {4;}' unless defined(&MCA_RH_TIME_MDAY);
    eval 'sub MCA_RH_TIME_MON () {5;}' unless defined(&MCA_RH_TIME_MON);
    eval 'sub MCA_RH_TIME_YEAR () {6;}' unless defined(&MCA_RH_TIME_YEAR);
    eval 'sub MCA_RH_TIME_CENT () {7;}' unless defined(&MCA_RH_TIME_CENT);
    eval 'sub MCA_SH_FLAGS_CORRECTED () {0x1;}' unless defined(&MCA_SH_FLAGS_CORRECTED);
    eval 'sub MCA_SH_FLAGS_PROPAGATE () {0x2;}' unless defined(&MCA_SH_FLAGS_PROPAGATE);
    eval 'sub MCA_SH_FLAGS_RESET () {0x4;}' unless defined(&MCA_SH_FLAGS_RESET);
    eval 'sub MCA_SH_FLAGS_VALID () {0x80;}' unless defined(&MCA_SH_FLAGS_VALID);
    eval 'sub MCA_CPU_FLAGS_ERRMAP () {(1 << 0);}' unless defined(&MCA_CPU_FLAGS_ERRMAP);
    eval 'sub MCA_CPU_FLAGS_STATE () {(1 << 1);}' unless defined(&MCA_CPU_FLAGS_STATE);
    eval 'sub MCA_CPU_FLAGS_CR_LID () {(1 << 2);}' unless defined(&MCA_CPU_FLAGS_CR_LID);
    eval 'sub MCA_CPU_FLAGS_PSI_STRUCT () {(1 << 3);}' unless defined(&MCA_CPU_FLAGS_PSI_STRUCT);
    eval 'sub MCA_CPU_FLAGS_CACHE {
        my($x) = @_;
	    eval q(((($x) >> 4) & 15));
    }' unless defined(&MCA_CPU_FLAGS_CACHE);
    eval 'sub MCA_CPU_FLAGS_TLB {
        my($x) = @_;
	    eval q(((($x) >> 8) & 15));
    }' unless defined(&MCA_CPU_FLAGS_TLB);
    eval 'sub MCA_CPU_FLAGS_BUS {
        my($x) = @_;
	    eval q(((($x) >> 12) & 15));
    }' unless defined(&MCA_CPU_FLAGS_BUS);
    eval 'sub MCA_CPU_FLAGS_REG {
        my($x) = @_;
	    eval q(((($x) >> 16) & 15));
    }' unless defined(&MCA_CPU_FLAGS_REG);
    eval 'sub MCA_CPU_FLAGS_MS {
        my($x) = @_;
	    eval q(((($x) >> 20) & 15));
    }' unless defined(&MCA_CPU_FLAGS_MS);
    eval 'sub MCA_CPU_FLAGS_CPUID () {(1 << 24);}' unless defined(&MCA_CPU_FLAGS_CPUID);
    eval 'sub MCA_CPU_MOD_FLAGS_INFO () {(1 << 0);}' unless defined(&MCA_CPU_MOD_FLAGS_INFO);
    eval 'sub MCA_CPU_MOD_FLAGS_REQID () {(1 << 1);}' unless defined(&MCA_CPU_MOD_FLAGS_REQID);
    eval 'sub MCA_CPU_MOD_FLAGS_RSPID () {(1 << 2);}' unless defined(&MCA_CPU_MOD_FLAGS_RSPID);
    eval 'sub MCA_CPU_MOD_FLAGS_TGTID () {(1 << 3);}' unless defined(&MCA_CPU_MOD_FLAGS_TGTID);
    eval 'sub MCA_CPU_MOD_FLAGS_IP () {(1 << 4);}' unless defined(&MCA_CPU_MOD_FLAGS_IP);
    eval 'sub MCA_CPU_PSI_FLAGS_STATE () {(1 << 0);}' unless defined(&MCA_CPU_PSI_FLAGS_STATE);
    eval 'sub MCA_CPU_PSI_FLAGS_BR () {(1 << 1);}' unless defined(&MCA_CPU_PSI_FLAGS_BR);
    eval 'sub MCA_CPU_PSI_FLAGS_CR () {(1 << 2);}' unless defined(&MCA_CPU_PSI_FLAGS_CR);
    eval 'sub MCA_CPU_PSI_FLAGS_AR () {(1 << 3);}' unless defined(&MCA_CPU_PSI_FLAGS_AR);
    eval 'sub MCA_CPU_PSI_FLAGS_RR () {(1 << 4);}' unless defined(&MCA_CPU_PSI_FLAGS_RR);
    eval 'sub MCA_CPU_PSI_FLAGS_FR () {(1 << 5);}' unless defined(&MCA_CPU_PSI_FLAGS_FR);
    eval 'sub MCA_MEM_FLAGS_STATUS () {(1 << 0);}' unless defined(&MCA_MEM_FLAGS_STATUS);
    eval 'sub MCA_MEM_FLAGS_ADDR () {(1 << 1);}' unless defined(&MCA_MEM_FLAGS_ADDR);
    eval 'sub MCA_MEM_FLAGS_ADDRMASK () {(1 << 2);}' unless defined(&MCA_MEM_FLAGS_ADDRMASK);
    eval 'sub MCA_MEM_FLAGS_NODE () {(1 << 3);}' unless defined(&MCA_MEM_FLAGS_NODE);
    eval 'sub MCA_MEM_FLAGS_CARD () {(1 << 4);}' unless defined(&MCA_MEM_FLAGS_CARD);
    eval 'sub MCA_MEM_FLAGS_MODULE () {(1 << 5);}' unless defined(&MCA_MEM_FLAGS_MODULE);
    eval 'sub MCA_MEM_FLAGS_BANK () {(1 << 6);}' unless defined(&MCA_MEM_FLAGS_BANK);
    eval 'sub MCA_MEM_FLAGS_DEVICE () {(1 << 7);}' unless defined(&MCA_MEM_FLAGS_DEVICE);
    eval 'sub MCA_MEM_FLAGS_ROW () {(1 << 8);}' unless defined(&MCA_MEM_FLAGS_ROW);
    eval 'sub MCA_MEM_FLAGS_COLUMN () {(1 << 9);}' unless defined(&MCA_MEM_FLAGS_COLUMN);
    eval 'sub MCA_MEM_FLAGS_BITPOS () {(1 << 10);}' unless defined(&MCA_MEM_FLAGS_BITPOS);
    eval 'sub MCA_MEM_FLAGS_REQID () {(1 << 11);}' unless defined(&MCA_MEM_FLAGS_REQID);
    eval 'sub MCA_MEM_FLAGS_RSPID () {(1 << 12);}' unless defined(&MCA_MEM_FLAGS_RSPID);
    eval 'sub MCA_MEM_FLAGS_TGTID () {(1 << 13);}' unless defined(&MCA_MEM_FLAGS_TGTID);
    eval 'sub MCA_MEM_FLAGS_BUSDATA () {(1 << 14);}' unless defined(&MCA_MEM_FLAGS_BUSDATA);
    eval 'sub MCA_MEM_FLAGS_OEM_ID () {(1 << 15);}' unless defined(&MCA_MEM_FLAGS_OEM_ID);
    eval 'sub MCA_MEM_FLAGS_OEM_DATA () {(1 << 16);}' unless defined(&MCA_MEM_FLAGS_OEM_DATA);
    eval 'sub MCA_PCIBUS_FLAGS_STATUS () {(1 << 0);}' unless defined(&MCA_PCIBUS_FLAGS_STATUS);
    eval 'sub MCA_PCIBUS_FLAGS_ERROR () {(1 << 1);}' unless defined(&MCA_PCIBUS_FLAGS_ERROR);
    eval 'sub MCA_PCIBUS_FLAGS_BUS () {(1 << 2);}' unless defined(&MCA_PCIBUS_FLAGS_BUS);
    eval 'sub MCA_PCIBUS_FLAGS_ADDR () {(1 << 3);}' unless defined(&MCA_PCIBUS_FLAGS_ADDR);
    eval 'sub MCA_PCIBUS_FLAGS_DATA () {(1 << 4);}' unless defined(&MCA_PCIBUS_FLAGS_DATA);
    eval 'sub MCA_PCIBUS_FLAGS_CMD () {(1 << 5);}' unless defined(&MCA_PCIBUS_FLAGS_CMD);
    eval 'sub MCA_PCIBUS_FLAGS_REQID () {(1 << 6);}' unless defined(&MCA_PCIBUS_FLAGS_REQID);
    eval 'sub MCA_PCIBUS_FLAGS_RSPID () {(1 << 7);}' unless defined(&MCA_PCIBUS_FLAGS_RSPID);
    eval 'sub MCA_PCIBUS_FLAGS_TGTID () {(1 << 8);}' unless defined(&MCA_PCIBUS_FLAGS_TGTID);
    eval 'sub MCA_PCIBUS_FLAGS_OEM_ID () {(1 << 9);}' unless defined(&MCA_PCIBUS_FLAGS_OEM_ID);
    eval 'sub MCA_PCIBUS_FLAGS_OEM_DATA () {(1 << 10);}' unless defined(&MCA_PCIBUS_FLAGS_OEM_DATA);
    eval 'sub MCA_PCIDEV_FLAGS_STATUS () {(1 << 0);}' unless defined(&MCA_PCIDEV_FLAGS_STATUS);
    eval 'sub MCA_PCIDEV_FLAGS_INFO () {(1 << 1);}' unless defined(&MCA_PCIDEV_FLAGS_INFO);
    eval 'sub MCA_PCIDEV_FLAGS_REG_MEM () {(1 << 2);}' unless defined(&MCA_PCIDEV_FLAGS_REG_MEM);
    eval 'sub MCA_PCIDEV_FLAGS_REG_IO () {(1 << 3);}' unless defined(&MCA_PCIDEV_FLAGS_REG_IO);
    eval 'sub MCA_PCIDEV_FLAGS_REG_DATA () {(1 << 4);}' unless defined(&MCA_PCIDEV_FLAGS_REG_DATA);
    eval 'sub MCA_PCIDEV_FLAGS_OEM_DATA () {(1 << 5);}' unless defined(&MCA_PCIDEV_FLAGS_OEM_DATA);
    eval 'sub MCA_PCIDEV_INFO_CLASS {
        my($x) = @_;
	    eval q((($x) & 0xffffff));
    }' unless defined(&MCA_PCIDEV_INFO_CLASS);
    eval 'sub MCA_PCIDEV_INFO_FUNCTION {
        my($x) = @_;
	    eval q(((($x) >> 24) & 0xff));
    }' unless defined(&MCA_PCIDEV_INFO_FUNCTION);
    eval 'sub MCA_UUID_CPU () {{0xe429faf1,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_CPU);
    eval 'sub MCA_UUID_MEMORY () {{0xe429faf2,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_MEMORY);
    eval 'sub MCA_UUID_SEL () {{0xe429faf3,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_SEL);
    eval 'sub MCA_UUID_PCI_BUS () {{0xe429faf4,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_PCI_BUS);
    eval 'sub MCA_UUID_SMBIOS () {{0xe429faf5,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_SMBIOS);
    eval 'sub MCA_UUID_PCI_DEV () {{0xe429faf6,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_PCI_DEV);
    eval 'sub MCA_UUID_GENERIC () {{0xe429faf7,0x3cb7,0x11d4,0xbc,0xa7,{0x,0x80,0xc7,0x3c,0x88,0x81}};}' unless defined(&MCA_UUID_GENERIC);
    if(defined(&_KERNEL)) {
    }
}
1;
