require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_MD_VAR_H_)) {
    eval 'sub _MACHINE_MD_VAR_H_ () {1;}' unless defined(&_MACHINE_MD_VAR_H_);
    eval 'sub FDESC_FUNC {
        my($fn) = @_;
	    eval q((( $fn)-> &func));
    }' unless defined(&FDESC_FUNC);
    eval 'sub FDESC_GP {
        my($fn) = @_;
	    eval q((( $fn)-> &gp));
    }' unless defined(&FDESC_GP);
    eval 'sub IA64_CFM_SOF {
        my($x) = @_;
	    eval q((($x) & 0x7f));
    }' unless defined(&IA64_CFM_SOF);
    eval 'sub IA64_CFM_SOL {
        my($x) = @_;
	    eval q(((($x) >> 7) & 0x7f));
    }' unless defined(&IA64_CFM_SOL);
    eval 'sub IA64_CFM_SOR {
        my($x) = @_;
	    eval q(((($x) >> 14) & 0xf));
    }' unless defined(&IA64_CFM_SOR);
    eval 'sub IA64_CFM_RRB_GR {
        my($x) = @_;
	    eval q(((($x) >> 18) & 0x7f));
    }' unless defined(&IA64_CFM_RRB_GR);
    eval 'sub IA64_CFM_RRB_FR {
        my($x) = @_;
	    eval q(((($x) >> 25) & 0x7f));
    }' unless defined(&IA64_CFM_RRB_FR);
    eval 'sub IA64_CFM_RRB_PR {
        my($x) = @_;
	    eval q(((($x) >> 32) & 0x3f));
    }' unless defined(&IA64_CFM_RRB_PR);
    if(defined(&_KERNEL)) {
    }
}
1;
