require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PCPU_H_)) {
    eval 'sub _MACHINE_PCPU_H_ () {1;}' unless defined(&_MACHINE_PCPU_H_);
    require 'sys/sysctl.ph';
    require 'machine/pcb.ph';
    if(defined(&_KERNEL)) {
    }
    eval 'sub PCPU_MD_FIELDS () { &uint32_t  &pc_acpi_id; \'struct pcpu_md\'  &pc_md; \'char\'  $__pad[10*128];}' unless defined(&PCPU_MD_FIELDS);
    if(defined(&_KERNEL)) {
	require 'sys/systm.ph';
	eval 'sub __curthread {
	    my($void) = @_;
    	    eval q({ \'struct thread\' * &td;  &__asm(\\"ld8.acq %0=[r13]\\" : \\"=r\\"( &td)); ( &td); });
	}' unless defined(&__curthread);
	eval 'sub curthread () {( &__curthread());}' unless defined(&curthread);
	eval 'sub __pcpu_offset {
	    my($name) = @_;
    	    eval q( &__offsetof(\'struct pcpu\', $name));
	}' unless defined(&__pcpu_offset);
	eval 'sub __pcpu_type {
	    my($name) = @_;
    	    eval q( &__typeof((0)->$name));
	}' unless defined(&__pcpu_type);
	eval 'sub PCPU_ADD {
	    my($name, $val) = @_;
    	    eval q( &do {  &__pcpu_type( &pc_  $name) * &nmp;  &critical_enter();  &__asm  &__volatile(\\"add %0=%1,r13;;\\" : \\"=r\\"( &nmp) : \\"i\\"( &__pcpu_offset( &pc_  $name))); * &nmp += $val;  &critical_exit(); }  &while (0));
	}' unless defined(&PCPU_ADD);
	eval 'sub PCPU_GET {
	    my($name) = @_;
    	    eval q(({  &__pcpu_type( &pc_  $name) * &nmp;  &__pcpu_type( &pc_  $name)  &res;  &critical_enter();  &__asm  &__volatile(\\"add %0=%1,r13;;\\" : \\"=r\\"( &nmp) : \\"i\\"( &__pcpu_offset( &pc_  $name)));  &res = * &nmp;  &critical_exit();  &res; }));
	}' unless defined(&PCPU_GET);
	eval 'sub PCPU_INC {
	    my($member) = @_;
    	    eval q( &PCPU_ADD($member, 1));
	}' unless defined(&PCPU_INC);
	eval 'sub PCPU_PTR {
	    my($name) = @_;
    	    eval q(({  &__pcpu_type( &pc_  $name) * &nmp;  &__asm  &__volatile(\\"add %0=%1,r13;;\\" : \\"=r\\"( &nmp) : \\"i\\"( &__pcpu_offset( &pc_  $name)));  &nmp; }));
	}' unless defined(&PCPU_PTR);
	eval 'sub PCPU_SET {
	    my($name, $val) = @_;
    	    eval q( &do {  &__pcpu_type( &pc_  $name) * &nmp;  &critical_enter();  &__asm  &__volatile(\\"add %0=%1,r13;;\\" : \\"=r\\"( &nmp) : \\"i\\"( &__pcpu_offset( &pc_  $name))); * &nmp = $val;  &critical_exit(); }  &while (0));
	}' unless defined(&PCPU_SET);
    }
}
1;
