require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_VMPARAM_H_)) {
    eval 'sub _MACHINE_VMPARAM_H_ () {1;}' unless defined(&_MACHINE_VMPARAM_H_);
    unless(defined(&MAXTSIZ)) {
	eval 'sub MAXTSIZ () {(1<<30);}' unless defined(&MAXTSIZ);
    }
    unless(defined(&DFLDSIZ)) {
	eval 'sub DFLDSIZ () {(1<<27);}' unless defined(&DFLDSIZ);
    }
    unless(defined(&MAXDSIZ)) {
	eval 'sub MAXDSIZ () {(1<<30);}' unless defined(&MAXDSIZ);
    }
    unless(defined(&DFLSSIZ)) {
	eval 'sub DFLSSIZ () {(1<<21);}' unless defined(&DFLSSIZ);
    }
    unless(defined(&MAXSSIZ)) {
	eval 'sub MAXSSIZ () {(1<<28);}' unless defined(&MAXSSIZ);
    }
    unless(defined(&SGROWSIZ)) {
	eval 'sub SGROWSIZ () {(128*1024);}' unless defined(&SGROWSIZ);
    }
    eval 'sub UMA_MD_SMALL_ALLOC () {1;}' unless defined(&UMA_MD_SMALL_ALLOC);
    eval 'sub VM_PHYSSEG_SPARSE () {1;}' unless defined(&VM_PHYSSEG_SPARSE);
    eval 'sub VM_PHYSSEG_MAX () {49;}' unless defined(&VM_PHYSSEG_MAX);
    eval 'sub VM_NFREEPOOL () {3;}' unless defined(&VM_NFREEPOOL);
    eval 'sub VM_FREEPOOL_CACHE () {2;}' unless defined(&VM_FREEPOOL_CACHE);
    eval 'sub VM_FREEPOOL_DEFAULT () {0;}' unless defined(&VM_FREEPOOL_DEFAULT);
    eval 'sub VM_FREEPOOL_DIRECT () {1;}' unless defined(&VM_FREEPOOL_DIRECT);
    eval 'sub VM_NFREELIST () {1;}' unless defined(&VM_NFREELIST);
    eval 'sub VM_FREELIST_DEFAULT () {0;}' unless defined(&VM_FREELIST_DEFAULT);
    eval 'sub VM_NFREEORDER () {16;}' unless defined(&VM_NFREEORDER);
    unless(defined(&VM_NRESERVLEVEL)) {
	eval 'sub VM_NRESERVLEVEL () {0;}' unless defined(&VM_NRESERVLEVEL);
    }
    eval 'sub IA64_VM_MINKERN_REGION () {4;}' unless defined(&IA64_VM_MINKERN_REGION);
    eval 'sub IA64_RR_BASE {
        my($n) = @_;
	    eval q(((( &uint64_t) ($n)) << 61));
    }' unless defined(&IA64_RR_BASE);
    eval 'sub IA64_RR_MASK {
        my($x) = @_;
	    eval q((($x) & ((1 << 61) - 1)));
    }' unless defined(&IA64_RR_MASK);
    eval 'sub IA64_PHYS_TO_RR6 {
        my($x) = @_;
	    eval q((($x) |  &IA64_RR_BASE(6)));
    }' unless defined(&IA64_PHYS_TO_RR6);
    eval 'sub IA64_PHYS_TO_RR7 {
        my($x) = @_;
	    eval q((($x) |  &IA64_RR_BASE(7)));
    }' unless defined(&IA64_PHYS_TO_RR7);
    eval 'sub IA64_REGION_GAP_START () {0x4000000000000;}' unless defined(&IA64_REGION_GAP_START);
    eval 'sub IA64_REGION_GAP_EXTEND () {0x1ffc000000000000;}' unless defined(&IA64_REGION_GAP_EXTEND);
    eval 'sub IA64_PBVM_RR () { &IA64_VM_MINKERN_REGION;}' unless defined(&IA64_PBVM_RR);
    eval 'sub IA64_PBVM_BASE () {( &IA64_RR_BASE( &IA64_PBVM_RR) +  &IA64_REGION_GAP_EXTEND);}' unless defined(&IA64_PBVM_BASE);
    eval 'sub IA64_PBVM_PGTBL_MAXSZ () {1048576;}' unless defined(&IA64_PBVM_PGTBL_MAXSZ);
    eval 'sub IA64_PBVM_PGTBL () {( &IA64_RR_BASE( &IA64_PBVM_RR + 1) -  &IA64_PBVM_PGTBL_MAXSZ);}' unless defined(&IA64_PBVM_PGTBL);
    eval 'sub IA64_PBVM_PAGE_SHIFT () {16;}' unless defined(&IA64_PBVM_PAGE_SHIFT);
    eval 'sub IA64_PBVM_PAGE_SIZE () {(1<<  &IA64_PBVM_PAGE_SHIFT);}' unless defined(&IA64_PBVM_PAGE_SIZE);
    eval 'sub IA64_PBVM_PAGE_MASK () {( &IA64_PBVM_PAGE_SIZE - 1);}' unless defined(&IA64_PBVM_PAGE_MASK);
    eval 'sub VM_MIN_ADDRESS () {0;}' unless defined(&VM_MIN_ADDRESS);
    eval 'sub VM_MAXUSER_ADDRESS () { &IA64_RR_BASE( &IA64_VM_MINKERN_REGION);}' unless defined(&VM_MAXUSER_ADDRESS);
    eval 'sub VM_MIN_KERNEL_ADDRESS () { &VM_MAXUSER_ADDRESS;}' unless defined(&VM_MIN_KERNEL_ADDRESS);
    eval 'sub VM_INIT_KERNEL_ADDRESS () { &IA64_RR_BASE( &IA64_VM_MINKERN_REGION + 1);}' unless defined(&VM_INIT_KERNEL_ADDRESS);
    eval 'sub VM_MAX_KERNEL_ADDRESS () {( &IA64_RR_BASE( &IA64_VM_MINKERN_REGION + 2) - 1);}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    eval 'sub VM_MAX_ADDRESS () {~0;}' unless defined(&VM_MAX_ADDRESS);
    eval 'sub KERNBASE () { &IA64_PBVM_BASE;}' unless defined(&KERNBASE);
    eval 'sub USRSTACK () { &VM_MAXUSER_ADDRESS;}' unless defined(&USRSTACK);
    eval 'sub IA64_BACKINGSTORE () {( &USRSTACK - (2*  &MAXSSIZ) -  &PAGE_SIZE);}' unless defined(&IA64_BACKINGSTORE);
    unless(defined(&VM_KMEM_SIZE_SCALE)) {
	eval 'sub VM_KMEM_SIZE_SCALE () {(4);}' unless defined(&VM_KMEM_SIZE_SCALE);
    }
    unless(defined(&VM_INITIAL_PAGEIN)) {
	eval 'sub VM_INITIAL_PAGEIN () {16;}' unless defined(&VM_INITIAL_PAGEIN);
    }
    eval 'sub ZERO_REGION_SIZE () {(2* 1024* 1024);}' unless defined(&ZERO_REGION_SIZE);
}
1;
