require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE__LIMITS_H_)) {
    eval 'sub _MACHINE__LIMITS_H_ () {1;}' unless defined(&_MACHINE__LIMITS_H_);
    eval 'sub __CHAR_BIT () {8;}' unless defined(&__CHAR_BIT);
    eval 'sub __SCHAR_MAX () {0x7f;}' unless defined(&__SCHAR_MAX);
    eval 'sub __SCHAR_MIN () {(-0x7f-1);}' unless defined(&__SCHAR_MIN);
    eval 'sub __UCHAR_MAX () {0xff;}' unless defined(&__UCHAR_MAX);
    eval 'sub __USHRT_MAX () {0xffff;}' unless defined(&__USHRT_MAX);
    eval 'sub __SHRT_MAX () {0x7fff;}' unless defined(&__SHRT_MAX);
    eval 'sub __SHRT_MIN () {(-0x7fff-1);}' unless defined(&__SHRT_MIN);
    eval 'sub __UINT_MAX () {0xffffffff;}' unless defined(&__UINT_MAX);
    eval 'sub __INT_MAX () {0x7fffffff;}' unless defined(&__INT_MAX);
    eval 'sub __INT_MIN () {(-0x7fffffff-1);}' unless defined(&__INT_MIN);
    eval 'sub __ULONG_MAX () {0xffffffffffffffff;}' unless defined(&__ULONG_MAX);
    eval 'sub __LONG_MAX () {0x7fffffffffffffff;}' unless defined(&__LONG_MAX);
    eval 'sub __LONG_MIN () {(-0x7fffffffffffffff-1);}' unless defined(&__LONG_MIN);
    eval 'sub __ULLONG_MAX () {0xffffffffffffffff;}' unless defined(&__ULLONG_MAX);
    eval 'sub __LLONG_MAX () {0x7fffffffffffffff;}' unless defined(&__LLONG_MAX);
    eval 'sub __LLONG_MIN () {(-0x7fffffffffffffff-1);}' unless defined(&__LLONG_MIN);
    eval 'sub __SSIZE_MAX () { &__LONG_MAX;}' unless defined(&__SSIZE_MAX);
    eval 'sub __SIZE_T_MAX () { &__ULONG_MAX;}' unless defined(&__SIZE_T_MAX);
    eval 'sub __OFF_MAX () { &__LONG_MAX;}' unless defined(&__OFF_MAX);
    eval 'sub __OFF_MIN () { &__LONG_MIN;}' unless defined(&__OFF_MIN);
    eval 'sub __UQUAD_MAX () {( &__ULONG_MAX);}' unless defined(&__UQUAD_MAX);
    eval 'sub __QUAD_MAX () {( &__LONG_MAX);}' unless defined(&__QUAD_MAX);
    eval 'sub __QUAD_MIN () {( &__LONG_MIN);}' unless defined(&__QUAD_MIN);
    eval 'sub __LONG_BIT () {64;}' unless defined(&__LONG_BIT);
    eval 'sub __WORD_BIT () {32;}' unless defined(&__WORD_BIT);
    eval 'sub __MINSIGSTKSZ () {(3072* 4);}' unless defined(&__MINSIGSTKSZ);
}
1;
