require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__ACPICA_MACHDEP_H__)) {
    eval 'sub __ACPICA_MACHDEP_H__ () {1;}' unless defined(&__ACPICA_MACHDEP_H__);
    if(defined(&_KERNEL)) {
	eval 'sub ACPI_SYSTEM_XFACE () {1;}' unless defined(&ACPI_SYSTEM_XFACE);
	eval 'sub ACPI_EXTERNAL_XFACE () {1;}' unless defined(&ACPI_EXTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_XFACE () {1;}' unless defined(&ACPI_INTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_VAR_XFACE () {1;}' unless defined(&ACPI_INTERNAL_VAR_XFACE);
	eval 'sub ACPI_ASM_MACROS () {1;}' unless defined(&ACPI_ASM_MACROS);
	eval 'sub BREAKPOINT3 () {1;}' unless defined(&BREAKPOINT3);
	eval 'sub ACPI_DISABLE_IRQS () {
	    eval q( &ia64_disable_intr());
	}' unless defined(&ACPI_DISABLE_IRQS);
	eval 'sub ACPI_ENABLE_IRQS () {
	    eval q( &ia64_enable_intr());
	}' unless defined(&ACPI_ENABLE_IRQS);
	eval 'sub ACPI_FLUSH_CPU_CACHE () {
	    eval q();
	}' unless defined(&ACPI_FLUSH_CPU_CACHE);
	eval 'sub ACPI_ACQUIRE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q( &do { ($Acq) =  &acpi_acquire_global_lock((($GLptr)-> &GlobalLock)); }  &while (0));
	}' unless defined(&ACPI_ACQUIRE_GLOBAL_LOCK);
	eval 'sub ACPI_RELEASE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q( &do { ($Acq) =  &acpi_release_global_lock((($GLptr)-> &GlobalLock)); }  &while (0));
	}' unless defined(&ACPI_RELEASE_GLOBAL_LOCK);
    }
}
1;
