require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPU_H_)) {
    eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
    require 'machine/frame.ph';
    eval 'sub TRAPF_PC {
        my($tf) = @_;
	    eval q((($tf)-> ($tf_special->{iip})));
    }' unless defined(&TRAPF_PC);
    eval 'sub TRAPF_CPL {
        my($tf) = @_;
	    eval q((($tf)-> ($tf_special->{psr}) &  &IA64_PSR_CPL));
    }' unless defined(&TRAPF_CPL);
    eval 'sub TRAPF_USERMODE {
        my($tf) = @_;
	    eval q(( &TRAPF_CPL($tf) !=  &IA64_PSR_CPL_KERN));
    }' unless defined(&TRAPF_USERMODE);
    if(defined(&_KERNEL)) {
	if(defined(&GPROF)) {
	}
	eval 'sub get_cyclecount () { &ia64_get_itc;}' unless defined(&get_cyclecount);
	eval 'sub cpu_getstack {
	    my($td) = @_;
    	    eval q((($td)-> ($td_frame->{tf_special}->{sp})));
	}' unless defined(&cpu_getstack);
	eval 'sub cpu_spinwait () {
	    eval q();
	}' unless defined(&cpu_spinwait);
    }
}
1;
