require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_FPU_H_)) {
    eval 'sub _MACHINE_FPU_H_ () {1;}' unless defined(&_MACHINE_FPU_H_);
    eval 'sub IA64_FPSR_TRAP_VD () {0x1;}' unless defined(&IA64_FPSR_TRAP_VD);
    eval 'sub IA64_FPSR_TRAP_DD () {0x2;}' unless defined(&IA64_FPSR_TRAP_DD);
    eval 'sub IA64_FPSR_TRAP_ZD () {0x4;}' unless defined(&IA64_FPSR_TRAP_ZD);
    eval 'sub IA64_FPSR_TRAP_OD () {0x8;}' unless defined(&IA64_FPSR_TRAP_OD);
    eval 'sub IA64_FPSR_TRAP_UD () {0x10;}' unless defined(&IA64_FPSR_TRAP_UD);
    eval 'sub IA64_FPSR_TRAP_ID () {0x20;}' unless defined(&IA64_FPSR_TRAP_ID);
    eval 'sub IA64_FPSR_SF {
        my($i,$v) = @_;
	    eval q((($v) << (($i)*13+6)));
    }' unless defined(&IA64_FPSR_SF);
    eval 'sub IA64_SF_FTZ () {0x1;}' unless defined(&IA64_SF_FTZ);
    eval 'sub IA64_SF_WRE () {0x2;}' unless defined(&IA64_SF_WRE);
    eval 'sub IA64_SF_PC () {0xc;}' unless defined(&IA64_SF_PC);
    eval 'sub IA64_SF_PC_0 () {0x;}' unless defined(&IA64_SF_PC_0);
    eval 'sub IA64_SF_PC_1 () {0x4;}' unless defined(&IA64_SF_PC_1);
    eval 'sub IA64_SF_PC_2 () {0x8;}' unless defined(&IA64_SF_PC_2);
    eval 'sub IA64_SF_PC_3 () {0xc;}' unless defined(&IA64_SF_PC_3);
    eval 'sub IA64_SF_RC () {0x30;}' unless defined(&IA64_SF_RC);
    eval 'sub IA64_SF_RC_NEAREST () {0x;}' unless defined(&IA64_SF_RC_NEAREST);
    eval 'sub IA64_SF_RC_NEGINF () {0x10;}' unless defined(&IA64_SF_RC_NEGINF);
    eval 'sub IA64_SF_RC_POSINF () {0x20;}' unless defined(&IA64_SF_RC_POSINF);
    eval 'sub IA64_SF_RC_TRUNC () {0x30;}' unless defined(&IA64_SF_RC_TRUNC);
    eval 'sub IA64_SF_TD () {0x40;}' unless defined(&IA64_SF_TD);
    eval 'sub IA64_SF_V () {0x80;}' unless defined(&IA64_SF_V);
    eval 'sub IA64_SF_D () {0x100;}' unless defined(&IA64_SF_D);
    eval 'sub IA64_SF_Z () {0x200;}' unless defined(&IA64_SF_Z);
    eval 'sub IA64_SF_O () {0x400;}' unless defined(&IA64_SF_O);
    eval 'sub IA64_SF_U () {0x800;}' unless defined(&IA64_SF_U);
    eval 'sub IA64_SF_I () {0x1000;}' unless defined(&IA64_SF_I);
    eval 'sub IA64_SF_DEFAULT () {( &IA64_SF_PC_3 |  &IA64_SF_RC_NEAREST);}' unless defined(&IA64_SF_DEFAULT);
    eval 'sub IA64_FPSR_DEFAULT () {( &IA64_FPSR_TRAP_VD |  &IA64_FPSR_TRAP_DD |  &IA64_FPSR_TRAP_ZD |  &IA64_FPSR_TRAP_OD |  &IA64_FPSR_TRAP_UD |  &IA64_FPSR_TRAP_ID |  &IA64_FPSR_SF(0,  &IA64_SF_DEFAULT) |  &IA64_FPSR_SF(1, ( &IA64_SF_DEFAULT |  &IA64_SF_TD |  &IA64_SF_WRE)) |  &IA64_FPSR_SF(2, ( &IA64_SF_DEFAULT |  &IA64_SF_TD)) |  &IA64_FPSR_SF(3, ( &IA64_SF_DEFAULT |  &IA64_SF_TD)));}' unless defined(&IA64_FPSR_DEFAULT);
}
1;
