require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_IA64_CPU_H_)) {
    eval 'sub _MACHINE_IA64_CPU_H_ () {1;}' unless defined(&_MACHINE_IA64_CPU_H_);
    eval 'sub IA64_LID_GET_SAPIC_ID {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xffff));
    }' unless defined(&IA64_LID_GET_SAPIC_ID);
    eval 'sub IA64_LID_SET_SAPIC_ID {
        my($x) = @_;
	    eval q(((($x) & 0xffff) << 16));
    }' unless defined(&IA64_LID_SET_SAPIC_ID);
    eval 'sub IA64_DCR_PP () {0x1;}' unless defined(&IA64_DCR_PP);
    eval 'sub IA64_DCR_BE () {0x2;}' unless defined(&IA64_DCR_BE);
    eval 'sub IA64_DCR_LC () {0x4;}' unless defined(&IA64_DCR_LC);
    eval 'sub IA64_DCR_DM () {0x100;}' unless defined(&IA64_DCR_DM);
    eval 'sub IA64_DCR_DP () {0x200;}' unless defined(&IA64_DCR_DP);
    eval 'sub IA64_DCR_DK () {0x400;}' unless defined(&IA64_DCR_DK);
    eval 'sub IA64_DCR_DX () {0x800;}' unless defined(&IA64_DCR_DX);
    eval 'sub IA64_DCR_DR () {0x1000;}' unless defined(&IA64_DCR_DR);
    eval 'sub IA64_DCR_DA () {0x2000;}' unless defined(&IA64_DCR_DA);
    eval 'sub IA64_DCR_DD () {0x4000;}' unless defined(&IA64_DCR_DD);
    eval 'sub IA64_DCR_DEFAULT () {( &IA64_DCR_DM |  &IA64_DCR_DP |  &IA64_DCR_DK |  &IA64_DCR_DX |  &IA64_DCR_DR |  &IA64_DCR_DA |  &IA64_DCR_DD);}' unless defined(&IA64_DCR_DEFAULT);
    eval 'sub IA64_PSR_BE () {0x2;}' unless defined(&IA64_PSR_BE);
    eval 'sub IA64_PSR_UP () {0x4;}' unless defined(&IA64_PSR_UP);
    eval 'sub IA64_PSR_AC () {0x8;}' unless defined(&IA64_PSR_AC);
    eval 'sub IA64_PSR_MFL () {0x10;}' unless defined(&IA64_PSR_MFL);
    eval 'sub IA64_PSR_MFH () {0x20;}' unless defined(&IA64_PSR_MFH);
    eval 'sub IA64_PSR_IC () {0x2000;}' unless defined(&IA64_PSR_IC);
    eval 'sub IA64_PSR_I () {0x4000;}' unless defined(&IA64_PSR_I);
    eval 'sub IA64_PSR_PK () {0x8000;}' unless defined(&IA64_PSR_PK);
    eval 'sub IA64_PSR_DT () {0x20000;}' unless defined(&IA64_PSR_DT);
    eval 'sub IA64_PSR_DFL () {0x40000;}' unless defined(&IA64_PSR_DFL);
    eval 'sub IA64_PSR_DFH () {0x80000;}' unless defined(&IA64_PSR_DFH);
    eval 'sub IA64_PSR_SP () {0x100000;}' unless defined(&IA64_PSR_SP);
    eval 'sub IA64_PSR_PP () {0x200000;}' unless defined(&IA64_PSR_PP);
    eval 'sub IA64_PSR_DI () {0x400000;}' unless defined(&IA64_PSR_DI);
    eval 'sub IA64_PSR_SI () {0x800000;}' unless defined(&IA64_PSR_SI);
    eval 'sub IA64_PSR_DB () {0x1000000;}' unless defined(&IA64_PSR_DB);
    eval 'sub IA64_PSR_LP () {0x2000000;}' unless defined(&IA64_PSR_LP);
    eval 'sub IA64_PSR_TB () {0x4000000;}' unless defined(&IA64_PSR_TB);
    eval 'sub IA64_PSR_RT () {0x8000000;}' unless defined(&IA64_PSR_RT);
    eval 'sub IA64_PSR_CPL () {0x300000000;}' unless defined(&IA64_PSR_CPL);
    eval 'sub IA64_PSR_CPL_KERN () {0x;}' unless defined(&IA64_PSR_CPL_KERN);
    eval 'sub IA64_PSR_CPL_1 () {0x100000000;}' unless defined(&IA64_PSR_CPL_1);
    eval 'sub IA64_PSR_CPL_2 () {0x200000000;}' unless defined(&IA64_PSR_CPL_2);
    eval 'sub IA64_PSR_CPL_USER () {0x300000000;}' unless defined(&IA64_PSR_CPL_USER);
    eval 'sub IA64_PSR_IS () {0x400000000;}' unless defined(&IA64_PSR_IS);
    eval 'sub IA64_PSR_MC () {0x800000000;}' unless defined(&IA64_PSR_MC);
    eval 'sub IA64_PSR_IT () {0x1000000000;}' unless defined(&IA64_PSR_IT);
    eval 'sub IA64_PSR_ID () {0x2000000000;}' unless defined(&IA64_PSR_ID);
    eval 'sub IA64_PSR_DA () {0x4000000000;}' unless defined(&IA64_PSR_DA);
    eval 'sub IA64_PSR_DD () {0x8000000000;}' unless defined(&IA64_PSR_DD);
    eval 'sub IA64_PSR_SS () {0x10000000000;}' unless defined(&IA64_PSR_SS);
    eval 'sub IA64_PSR_RI () {0x60000000000;}' unless defined(&IA64_PSR_RI);
    eval 'sub IA64_PSR_RI_0 () {0x;}' unless defined(&IA64_PSR_RI_0);
    eval 'sub IA64_PSR_RI_1 () {0x20000000000;}' unless defined(&IA64_PSR_RI_1);
    eval 'sub IA64_PSR_RI_2 () {0x40000000000;}' unless defined(&IA64_PSR_RI_2);
    eval 'sub IA64_PSR_ED () {0x80000000000;}' unless defined(&IA64_PSR_ED);
    eval 'sub IA64_PSR_BN () {0x100000000000;}' unless defined(&IA64_PSR_BN);
    eval 'sub IA64_PSR_IA () {0x200000000000;}' unless defined(&IA64_PSR_IA);
    eval 'sub IA64_ISR_CODE () {0xffff;}' unless defined(&IA64_ISR_CODE);
    eval 'sub IA64_ISR_VECTOR () {0xff0000;}' unless defined(&IA64_ISR_VECTOR);
    eval 'sub IA64_ISR_X () {0x100000000;}' unless defined(&IA64_ISR_X);
    eval 'sub IA64_ISR_W () {0x200000000;}' unless defined(&IA64_ISR_W);
    eval 'sub IA64_ISR_R () {0x400000000;}' unless defined(&IA64_ISR_R);
    eval 'sub IA64_ISR_NA () {0x800000000;}' unless defined(&IA64_ISR_NA);
    eval 'sub IA64_ISR_SP () {0x1000000000;}' unless defined(&IA64_ISR_SP);
    eval 'sub IA64_ISR_RS () {0x2000000000;}' unless defined(&IA64_ISR_RS);
    eval 'sub IA64_ISR_IR () {0x4000000000;}' unless defined(&IA64_ISR_IR);
    eval 'sub IA64_ISR_NI () {0x8000000000;}' unless defined(&IA64_ISR_NI);
    eval 'sub IA64_ISR_SO () {0x10000000000;}' unless defined(&IA64_ISR_SO);
    eval 'sub IA64_ISR_EI () {0x60000000000;}' unless defined(&IA64_ISR_EI);
    eval 'sub IA64_ISR_EI_0 () {0x;}' unless defined(&IA64_ISR_EI_0);
    eval 'sub IA64_ISR_EI_1 () {0x20000000000;}' unless defined(&IA64_ISR_EI_1);
    eval 'sub IA64_ISR_EI_2 () {0x40000000000;}' unless defined(&IA64_ISR_EI_2);
    eval 'sub IA64_ISR_ED () {0x80000000000;}' unless defined(&IA64_ISR_ED);
    eval 'sub IA64_VEC_VHPT () {0;}' unless defined(&IA64_VEC_VHPT);
    eval 'sub IA64_VEC_ITLB () {1;}' unless defined(&IA64_VEC_ITLB);
    eval 'sub IA64_VEC_DTLB () {2;}' unless defined(&IA64_VEC_DTLB);
    eval 'sub IA64_VEC_ALT_ITLB () {3;}' unless defined(&IA64_VEC_ALT_ITLB);
    eval 'sub IA64_VEC_ALT_DTLB () {4;}' unless defined(&IA64_VEC_ALT_DTLB);
    eval 'sub IA64_VEC_NESTED_DTLB () {5;}' unless defined(&IA64_VEC_NESTED_DTLB);
    eval 'sub IA64_VEC_IKEY_MISS () {6;}' unless defined(&IA64_VEC_IKEY_MISS);
    eval 'sub IA64_VEC_DKEY_MISS () {7;}' unless defined(&IA64_VEC_DKEY_MISS);
    eval 'sub IA64_VEC_DIRTY_BIT () {8;}' unless defined(&IA64_VEC_DIRTY_BIT);
    eval 'sub IA64_VEC_INST_ACCESS () {9;}' unless defined(&IA64_VEC_INST_ACCESS);
    eval 'sub IA64_VEC_DATA_ACCESS () {10;}' unless defined(&IA64_VEC_DATA_ACCESS);
    eval 'sub IA64_VEC_BREAK () {11;}' unless defined(&IA64_VEC_BREAK);
    eval 'sub IA64_VEC_EXT_INTR () {12;}' unless defined(&IA64_VEC_EXT_INTR);
    eval 'sub IA64_VEC_PAGE_NOT_PRESENT () {20;}' unless defined(&IA64_VEC_PAGE_NOT_PRESENT);
    eval 'sub IA64_VEC_KEY_PERMISSION () {21;}' unless defined(&IA64_VEC_KEY_PERMISSION);
    eval 'sub IA64_VEC_INST_ACCESS_RIGHTS () {22;}' unless defined(&IA64_VEC_INST_ACCESS_RIGHTS);
    eval 'sub IA64_VEC_DATA_ACCESS_RIGHTS () {23;}' unless defined(&IA64_VEC_DATA_ACCESS_RIGHTS);
    eval 'sub IA64_VEC_GENERAL_EXCEPTION () {24;}' unless defined(&IA64_VEC_GENERAL_EXCEPTION);
    eval 'sub IA64_VEC_DISABLED_FP () {25;}' unless defined(&IA64_VEC_DISABLED_FP);
    eval 'sub IA64_VEC_NAT_CONSUMPTION () {26;}' unless defined(&IA64_VEC_NAT_CONSUMPTION);
    eval 'sub IA64_VEC_SPECULATION () {27;}' unless defined(&IA64_VEC_SPECULATION);
    eval 'sub IA64_VEC_DEBUG () {29;}' unless defined(&IA64_VEC_DEBUG);
    eval 'sub IA64_VEC_UNALIGNED_REFERENCE () {30;}' unless defined(&IA64_VEC_UNALIGNED_REFERENCE);
    eval 'sub IA64_VEC_UNSUPP_DATA_REFERENCE () {31;}' unless defined(&IA64_VEC_UNSUPP_DATA_REFERENCE);
    eval 'sub IA64_VEC_FLOATING_POINT_FAULT () {32;}' unless defined(&IA64_VEC_FLOATING_POINT_FAULT);
    eval 'sub IA64_VEC_FLOATING_POINT_TRAP () {33;}' unless defined(&IA64_VEC_FLOATING_POINT_TRAP);
    eval 'sub IA64_VEC_LOWER_PRIVILEGE_TRANSFER () {34;}' unless defined(&IA64_VEC_LOWER_PRIVILEGE_TRANSFER);
    eval 'sub IA64_VEC_TAKEN_BRANCH_TRAP () {35;}' unless defined(&IA64_VEC_TAKEN_BRANCH_TRAP);
    eval 'sub IA64_VEC_SINGLE_STEP_TRAP () {36;}' unless defined(&IA64_VEC_SINGLE_STEP_TRAP);
    eval 'sub IA64_VEC_IA32_EXCEPTION () {45;}' unless defined(&IA64_VEC_IA32_EXCEPTION);
    eval 'sub IA64_VEC_IA32_INTERCEPT () {46;}' unless defined(&IA64_VEC_IA32_INTERCEPT);
    eval 'sub IA64_VEC_IA32_INTERRUPT () {47;}' unless defined(&IA64_VEC_IA32_INTERRUPT);
    eval 'sub IA32_EXCEPTION_DIVIDE () {0;}' unless defined(&IA32_EXCEPTION_DIVIDE);
    eval 'sub IA32_EXCEPTION_DEBUG () {1;}' unless defined(&IA32_EXCEPTION_DEBUG);
    eval 'sub IA32_EXCEPTION_BREAK () {3;}' unless defined(&IA32_EXCEPTION_BREAK);
    eval 'sub IA32_EXCEPTION_OVERFLOW () {4;}' unless defined(&IA32_EXCEPTION_OVERFLOW);
    eval 'sub IA32_EXCEPTION_BOUND () {5;}' unless defined(&IA32_EXCEPTION_BOUND);
    eval 'sub IA32_EXCEPTION_DNA () {7;}' unless defined(&IA32_EXCEPTION_DNA);
    eval 'sub IA32_EXCEPTION_NOT_PRESENT () {11;}' unless defined(&IA32_EXCEPTION_NOT_PRESENT);
    eval 'sub IA32_EXCEPTION_STACK_FAULT () {12;}' unless defined(&IA32_EXCEPTION_STACK_FAULT);
    eval 'sub IA32_EXCEPTION_GPFAULT () {13;}' unless defined(&IA32_EXCEPTION_GPFAULT);
    eval 'sub IA32_EXCEPTION_FPERROR () {16;}' unless defined(&IA32_EXCEPTION_FPERROR);
    eval 'sub IA32_EXCEPTION_ALIGNMENT_CHECK () {17;}' unless defined(&IA32_EXCEPTION_ALIGNMENT_CHECK);
    eval 'sub IA32_EXCEPTION_STREAMING_SIMD () {19;}' unless defined(&IA32_EXCEPTION_STREAMING_SIMD);
    eval 'sub IA32_INTERCEPT_INSTRUCTION () {0;}' unless defined(&IA32_INTERCEPT_INSTRUCTION);
    eval 'sub IA32_INTERCEPT_GATE () {1;}' unless defined(&IA32_INTERCEPT_GATE);
    eval 'sub IA32_INTERCEPT_SYSTEM_FLAG () {2;}' unless defined(&IA32_INTERCEPT_SYSTEM_FLAG);
    eval 'sub IA32_INTERCEPT_LOCK () {4;}' unless defined(&IA32_INTERCEPT_LOCK);
    unless(defined(&LOCORE)) {
	eval 'sub ia64_mf_a {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"mf.a\\"); });
	}' unless defined(&ia64_mf_a);
	eval 'sub ia64_fc_i {
	    my($va) = @_;
    	    eval q({  &__asm  &__volatile(\\"fc.i %0\\" :: \\"r\\"($va)); });
	}' unless defined(&ia64_fc_i);
	eval 'sub ia64_ld2 {
	    my($p) = @_;
    	    eval q({  &uint16_t  &v;  &__asm  &__volatile(\\"ld2 %0=[%1];;\\" : \\"=r\\"( &v) : \\"r\\"($p)); ( &v); });
	}' unless defined(&ia64_ld2);
	eval 'sub ia64_ld4 {
	    my($p) = @_;
    	    eval q({  &uint32_t  &v;  &__asm  &__volatile(\\"ld4 %0=[%1];;\\" : \\"=r\\"( &v) : \\"r\\"($p)); ( &v); });
	}' unless defined(&ia64_ld4);
	eval 'sub ia64_ld8 {
	    my($p) = @_;
    	    eval q({  &uint64_t  &v;  &__asm  &__volatile(\\"ld8 %0=[%1];;\\" : \\"=r\\"( &v) : \\"r\\"($p)); ( &v); });
	}' unless defined(&ia64_ld8);
	eval 'sub ia64_st2 {
	    my($p,$v) = @_;
    	    eval q({  &__asm  &__volatile(\\"st2 [%0]=%1;;\\" :: \\"r\\"($p), \\"r\\"($v)); });
	}' unless defined(&ia64_st2);
	eval 'sub ia64_st4 {
	    my($p,$v) = @_;
    	    eval q({  &__asm  &__volatile(\\"st4 [%0]=%1;;\\" :: \\"r\\"($p), \\"r\\"($v)); });
	}' unless defined(&ia64_st4);
	eval 'sub ia64_st8 {
	    my($p,$v) = @_;
    	    eval q({  &__asm  &__volatile(\\"st8 [%0]=%1;;\\" :: \\"r\\"($p), \\"r\\"($v)); });
	}' unless defined(&ia64_st8);
	eval 'sub IA64_AR {
	    my($name) = @_;
    	    eval q( &static  &__inline  &uint64_t  &ia64_get_$name( &void) {  &uint64_t  &result;  &__asm  &__volatile(\\"mov %0=ar.\\" $name : \\"=r\\" ( &result));  &return  &result; }  &static  &__inline  &void  &ia64_set_$name( &uint64_t  &v) {  &__asm  &__volatile(\\"mov ar.\\" $name \\"=%0;;\\" :: \\"r\\" ( &v)); });
	}' unless defined(&IA64_AR);
	eval 'sub IA64_CR {
	    my($name) = @_;
    	    eval q( &static  &__inline  &uint64_t  &ia64_get_$name( &void) {  &uint64_t  &result;  &__asm  &__volatile(\\"mov %0=cr.\\" $name : \\"=r\\" ( &result));  &return  &result; }  &static  &__inline  &void  &ia64_set_$name( &uint64_t  &v) {  &__asm  &__volatile(\\"mov cr.\\" $name \\"=%0;;\\" :: \\"r\\" ( &v)); });
	}' unless defined(&IA64_CR);
	eval 'sub ia64_disable_highfp {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"ssm psr.dfh;; srlz.d\\"); });
	}' unless defined(&ia64_disable_highfp);
	eval 'sub ia64_enable_highfp {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"rsm psr.dfh;; srlz.d\\"); });
	}' unless defined(&ia64_enable_highfp);
	eval 'sub ia64_srlz_d () {
	    eval q( &__asm  &__volatile(\\"srlz.d\\"));
	}' unless defined(&ia64_srlz_d);
	eval 'sub ia64_srlz_i () {
	    eval q( &__asm  &__volatile(\\"srlz.i;;\\"));
	}' unless defined(&ia64_srlz_i);
    }
}
1;
