require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_IODEV_H_)) {
    eval 'sub _MACHINE_IODEV_H_ () {1;}' unless defined(&_MACHINE_IODEV_H_);
    require 'sys/uuid.ph';
    if(defined(&_KERNEL)) {
	require 'machine/bus.ph';
    }
    eval 'sub IODEV_EFIVAR_GETVAR () {0;}' unless defined(&IODEV_EFIVAR_GETVAR);
    eval 'sub IODEV_EFIVAR_NEXTNAME () {1;}' unless defined(&IODEV_EFIVAR_NEXTNAME);
    eval 'sub IODEV_EFIVAR_SETVAR () {2;}' unless defined(&IODEV_EFIVAR_SETVAR);
    eval 'sub IODEV_EFIVAR () { &_IOWR(ord(\'I\'), 1, \'struct iodev_efivar_req\');}' unless defined(&IODEV_EFIVAR);
    if(defined(&_KERNEL)) {
	eval 'sub iodev_read_1 () { &bus_space_read_io_1;}' unless defined(&iodev_read_1);
	eval 'sub iodev_read_2 () { &bus_space_read_io_2;}' unless defined(&iodev_read_2);
	eval 'sub iodev_read_4 () { &bus_space_read_io_4;}' unless defined(&iodev_read_4);
	eval 'sub iodev_write_1 () { &bus_space_write_io_1;}' unless defined(&iodev_write_1);
	eval 'sub iodev_write_2 () { &bus_space_write_io_2;}' unless defined(&iodev_write_2);
	eval 'sub iodev_write_4 () { &bus_space_write_io_4;}' unless defined(&iodev_write_4);
    }
}
1;
