require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PROFILE_H_)) {
    eval 'sub _MACHINE_PROFILE_H_ () {1;}' unless defined(&_MACHINE_PROFILE_H_);
    eval 'sub _MCOUNT_DECL () { &void  &__mcount;}' unless defined(&_MCOUNT_DECL);
    eval 'sub MCOUNT () {1;}' unless defined(&MCOUNT);
    eval 'sub FUNCTION_ALIGNMENT () {16;}' unless defined(&FUNCTION_ALIGNMENT);
    if(defined(&_KERNEL)) {
	eval 'sub MCOUNT_ENTER {
	    my($s) = @_;
    	    eval q($s =  &intr_disable());
	}' unless defined(&MCOUNT_ENTER);
	eval 'sub MCOUNT_EXIT {
	    my($s) = @_;
    	    eval q( &intr_restore($s));
	}' unless defined(&MCOUNT_EXIT);
	eval 'sub MCOUNT_DECL {
	    my($s) = @_;
    	    eval q( &register_t $s;);
	}' unless defined(&MCOUNT_DECL);
	eval 'sub MCOUNT_FROMPC_USER {
	    my($pc) = @_;
    	    eval q((($pc < ( &uintfptr_t) &VM_MAXUSER_ADDRESS) ? ~0 : $pc));
	}' unless defined(&MCOUNT_FROMPC_USER);
	eval 'sub MCOUNT_FROMPC_INTR {
	    my($pc) = @_;
    	    eval q((~0));
	}' unless defined(&MCOUNT_FROMPC_INTR);
    } else {
    }
}
1;
