require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PTE_H_)) {
    eval 'sub _MACHINE_PTE_H_ () {1;}' unless defined(&_MACHINE_PTE_H_);
    eval 'sub PTE_PRESENT () {0x1;}' unless defined(&PTE_PRESENT);
    eval 'sub PTE__RV1_ () {0x2;}' unless defined(&PTE__RV1_);
    eval 'sub PTE_MA_MASK () {0x1c;}' unless defined(&PTE_MA_MASK);
    eval 'sub PTE_MA_WB () {0x;}' unless defined(&PTE_MA_WB);
    eval 'sub PTE_MA_UC () {0x10;}' unless defined(&PTE_MA_UC);
    eval 'sub PTE_MA_UCE () {0x14;}' unless defined(&PTE_MA_UCE);
    eval 'sub PTE_MA_WC () {0x18;}' unless defined(&PTE_MA_WC);
    eval 'sub PTE_MA_NATPAGE () {0x1c;}' unless defined(&PTE_MA_NATPAGE);
    eval 'sub PTE_ACCESSED () {0x20;}' unless defined(&PTE_ACCESSED);
    eval 'sub PTE_DIRTY () {0x40;}' unless defined(&PTE_DIRTY);
    eval 'sub PTE_PL_MASK () {0x180;}' unless defined(&PTE_PL_MASK);
    eval 'sub PTE_PL_KERN () {0x;}' unless defined(&PTE_PL_KERN);
    eval 'sub PTE_PL_USER () {0x180;}' unless defined(&PTE_PL_USER);
    eval 'sub PTE_AR_MASK () {0xe00;}' unless defined(&PTE_AR_MASK);
    eval 'sub PTE_AR_R () {0x;}' unless defined(&PTE_AR_R);
    eval 'sub PTE_AR_RX () {0x200;}' unless defined(&PTE_AR_RX);
    eval 'sub PTE_AR_RW () {0x400;}' unless defined(&PTE_AR_RW);
    eval 'sub PTE_AR_RWX () {0x600;}' unless defined(&PTE_AR_RWX);
    eval 'sub PTE_AR_R_RW () {0x800;}' unless defined(&PTE_AR_R_RW);
    eval 'sub PTE_AR_RX_RWX () {0xa00;}' unless defined(&PTE_AR_RX_RWX);
    eval 'sub PTE_AR_RWX_RW () {0xc00;}' unless defined(&PTE_AR_RWX_RW);
    eval 'sub PTE_AR_X_RX () {0xe00;}' unless defined(&PTE_AR_X_RX);
    eval 'sub PTE_PPN_MASK () {0x3fffffffff000;}' unless defined(&PTE_PPN_MASK);
    eval 'sub PTE__RV2_ () {0xc000000000000;}' unless defined(&PTE__RV2_);
    eval 'sub PTE_ED () {0x10000000000000;}' unless defined(&PTE_ED);
    eval 'sub PTE_IG_MASK () {0xffe0000000000000;}' unless defined(&PTE_IG_MASK);
    eval 'sub PTE_WIRED () {0x20000000000000;}' unless defined(&PTE_WIRED);
    eval 'sub PTE_MANAGED () {0x40000000000000;}' unless defined(&PTE_MANAGED);
    eval 'sub PTE_PROT_MASK () {0x700000000000000;}' unless defined(&PTE_PROT_MASK);
    eval 'sub ITIR__RV1_ () {0x3;}' unless defined(&ITIR__RV1_);
    eval 'sub ITIR_PS_MASK () {0xfc;}' unless defined(&ITIR_PS_MASK);
    eval 'sub ITIR_KEY_MASK () {0xffffff00;}' unless defined(&ITIR_KEY_MASK);
    eval 'sub ITIR__RV2_ () {0xffffffff00000000;}' unless defined(&ITIR__RV2_);
    unless(defined(&LOCORE)) {
	eval 'sub pte_atomic_clear {
	    my($ptep,$val) = @_;
    	    eval q({ ( &atomic_clear_64($ptep, $val)); });
	}' unless defined(&pte_atomic_clear);
	eval 'sub pte_atomic_set {
	    my($ptep,$val) = @_;
    	    eval q({ ( &atomic_set_64($ptep, $val)); });
	}' unless defined(&pte_atomic_set);
    }
}
1;
